#include "code/framework/fx/impl/global/multi/SerialGlobalEffect.h"
using namespace std;

SerialGlobalEffect::SerialGlobalEffect(int nbLoops)
{
	m_effects=new vector<AbstractGlobalEffect *>();
	m_currentEffect=0;
	m_nbLoops=nbLoops;
	m_currentLoop=0;
}

SerialGlobalEffect::~SerialGlobalEffect()
{
	vector<AbstractGlobalEffect *>::iterator it;
	for (it=m_effects->begin(); it<m_effects->end();it++)
    {
    	delete *it;
    }
    delete m_effects;
}


void SerialGlobalEffect::start()
{
	if(m_currentEffect<m_effects->size())
	{
		m_effects->at(m_currentEffect)->start();	
	}
}

void SerialGlobalEffect::restart()
{
	/*if(m_currentEffect<m_effects->size())
	{
		m_effects->at(m_currentEffect)->stop();
		m_effects->at(m_currentEffect)->reset();
	}*/
	
	
	vector<AbstractGlobalEffect *>::iterator it;
	for (it=m_effects->begin(); it<m_effects->end();it++)
    {
    	AbstractGlobalEffect *agfx = *it;
    	agfx->stop();
    	agfx->reset();
    }
	
	m_currentEffect=0;
	m_currentLoop=0;
	start();
}

void SerialGlobalEffect::reset()
{
	if(m_currentEffect<m_effects->size())
	{
		m_effects->at(m_currentEffect)->reset();
	}
	m_currentEffect=0;
	m_currentLoop=0;
}

void SerialGlobalEffect::stop()
{
	if(m_currentEffect<m_effects->size())
	{
		m_effects->at(m_currentEffect)->stop();
	}
}

void SerialGlobalEffect::update()
{
	if(m_currentEffect<m_effects->size() && m_effects->at(m_currentEffect)->isRunning())
	{
		m_effects->at(m_currentEffect)->update();
		if(m_effects->at(m_currentEffect)->finished())
		{
			//m_effects[m_currentEffect]->stop();
			//m_effects->at(m_currentEffect)->reset();
			m_effects->at(m_currentEffect)->stop();
			m_currentEffect++;
			if(m_currentEffect<m_effects->size())
			{
				m_effects->at(m_currentEffect)->reset();
				m_effects->at(m_currentEffect)->start(); //on a vu que le précedent etait en marche, c'est une condition pour etre la
			}
			else
			{
				m_currentLoop++;
				if(m_nbLoops==-1 || m_currentLoop<m_nbLoops)
				{
					m_currentEffect=0;
					m_effects->at(m_currentEffect)->reset();
					m_effects->at(m_currentEffect)->start();	
				}	
			}
		}
	}
}

bool SerialGlobalEffect::finished()
{
	if(m_nbLoops!=-1 && m_currentLoop>=m_nbLoops)
		return true;
	return false;
}

bool SerialGlobalEffect::isRunning()
{
	if(m_currentEffect<m_effects->size())
	{
		return m_effects->at(m_currentEffect)->isRunning();
	}
	return false;
}

void SerialGlobalEffect::activate()
{
	if(m_currentEffect<m_effects->size())
	{
		m_effects->at(m_currentEffect)->activate();
	}
	else
	{
		m_effects->at(m_currentEffect-1)->activate();
	}
}

void SerialGlobalEffect::addEffect(AbstractGlobalEffect * fx)
{
	m_effects->push_back(fx);
}

SerialGlobalEffect* SerialGlobalEffect::clone() const
{
	SerialGlobalEffect *sge = new SerialGlobalEffect(m_nbLoops);
	vector<AbstractGlobalEffect *>::iterator it;
	for (it=m_effects->begin(); it!=m_effects->end();it++)
    {
    	sge->addEffect((*it)->clone());
    }
	return sge;
}







