#ifndef GRAVITYEFFECT_H_
#define GRAVITYEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"

class GravityEffect : public AbstractLocalEffect
{
	private:
		bool m_running;
		float m_originalVelocityX;
		float m_originalVelocityY;
		float m_velocityX; //current
		float m_velocityY; //current
		float m_accelerationX;
		float m_accelerationY;
		int m_nbTicks;
		int m_stopAtNbTicks;
		
		//parcours deja effectué
		float m_posX;
		float m_posY;
	
	public:
		GravityEffect(float originalVelocityX, float originalVelocityY, float accelerationX, float accelerationY, int stopAtNbTicks=-1); //-1=never stop
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *img); 
		Positionable *applyOnPositionable(Positionable *obj);
		GravityEffect* clone() const;	
		
		
		//getters et setters:
		void setAccelerationX(float ax);
		void setAccelerationY(float ay);
		float getAccelerationX();
		float getAccelerationY();
		
		int getPosX();
		int getPosY();
};

#endif /*GRAVITYEFFECT_H_*/
