#ifndef SIZEWOWEFFECT_H_
#define SIZEWOWEFFECT_H_
#include "code/framework/fx/abstract/AbstractLocalEffect.h"

class SizeWowEffect : public AbstractLocalEffect
{
	private:
		bool m_startSmall;
		bool m_growing;
		int m_growTime;
		int m_shrinkTime;
		int m_currentTick;
		
		bool m_running;
		int m_shrinkPercentX;
		int m_growPercentX;
		int m_shrinkPercentY;
		int m_growPercentY;
		int m_nbLoops;
		int m_currentLoop;
	
	public:
		SizeWowEffect(int shrinkPercentX, int growPercentX,int shrinkPercentY, int growPercentY, int growTime, int shrinkTime, bool startSmall=true, int nbLoops=-1);
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *); 
		Resizable *applyOnResizable(Resizable *obj);
		
		SizeWowEffect* clone() const;
		
		int getShrinkingTime();
		void setShrinkingTime(int time);
		int getGrowingTime();
		void setGrowingTime(int time);
		int getGrowPercentX();
		int getShrinkPercentX();
		int getGrowPercentY();
		int getShrinkPercentY();
		
};

#endif /*SIZEWOWEFFECT_H_*/
