#ifndef TRANSLATIONEFFECT_H_
#define TRANSLATIONEFFECT_H_
#include "code/framework/fx/abstract/AbstractLocalEffect.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/Pos.h"


class TranslationEffect : public AbstractLocalEffect
{
	private:
		bool m_running;
		
		int m_time01;
		int m_time10;
		float m_x0;
		float m_x1;
		float m_y0;
		float m_y1;
		bool m_start0;
		bool m_direction;
		int m_nbLoops;
		int m_curLoop;
		
		Pos calculateDiff();
		
		int m_curTime;
		
		//distance entre chaque frame
		float m_dist01FramesX;
		float m_dist01FramesY;
		float m_dist10FramesX;
		float m_dist10FramesY;
		
		//position actuelle
		float m_curX;
		float m_curY;
		
		//distance à parcourir
		int m_distanceTotalX;
		int m_distanceTotalY;
		
		//distance parcourue
		float m_distanceCurrentX;
		float m_distanceCurrentY;
	
	public:
		TranslationEffect(int x0, int y0, int x1, int y1, int time01, int time10, bool start0=true, int nbLoops=-1);
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *); 
		Positionable *applyOnPositionable(Positionable *obj);
		
		TranslationEffect* clone() const;
		
		//effect on positionable
		//Positionable * applyOn(Positionable *positionableObject);
		
		int getTimeForward();
		void setTimeForward(int time);
		int getTimeBackWard();
		void setTimeBackward(int time);
		Pos getStartPos();
		Pos getEndPos();
		Pos getCurrentPos();
		
		int getPosX();
		int getPosY();
		
};
#endif /*TRANSLATIONEFFECT_H_*/
