#ifndef SERIALLOCALEFFECT_H_
#define SERIALLOCALEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"
#include <vector>
using namespace std;

//prend en charge la destruction du contenu
class SerialLocalEffect : public AbstractLocalEffect
{
	private:
		vector<AbstractLocalEffect *> *m_effects;
		unsigned int m_currentEffect;
		int m_nbLoops;
		int m_currentLoop;
	
	public:
		SerialLocalEffect(int nbLoops=-1);
		~SerialLocalEffect();
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *);
		Positionable *applyOnPositionable(Positionable *obj);
		Orientable *applyOnOrientable(Orientable *obj);
		Resizable *applyOnResizable(Resizable *obj);
		
		void addEffect(AbstractLocalEffect * fx);
		SerialLocalEffect* clone() const;
		
		int getPosX();
		int getPosY();
};

#endif /*SERIALLOCALEFFECT_H_*/
