#ifndef WAITLOCALEFFECT_H_
#define WAITLOCALEFFECT_H_

#include "code/framework/fx/abstract/AbstractLocalEffect.h"

class WaitLocalEffect : public AbstractLocalEffect
{
	private:
		bool m_running;
		unsigned int m_time;
		unsigned int m_currentTick;
		bool m_showImage;
		float m_sizeXpercent;
		float m_sizeYpercent;
		int m_distX;
		int m_distY;
		int m_angle;
	
	public:
		WaitLocalEffect(unsigned int time, bool showImage=true);
	
		void start(); 
		void restart();
		void reset();
		void stop();
		void update();
		bool finished();
		bool isRunning();
		OSL_IMAGE * applyOn(OSL_IMAGE *); 
		Positionable *applyOnPositionable(Positionable *obj);
		Orientable *applyOnOrientable(Orientable *obj);
		Resizable *applyOnResizable(Resizable *obj);
		
		WaitLocalEffect* clone() const;
		
		unsigned int getTime();
		void setTime(unsigned int time);
		
		void setPosition(int x, int y);
		void setSizePercent(float w, float h);
		void setDirection(int angle);
		
		int getPosX();
		int getPosY();
};


#endif /*WAITLOCALEFFECT_H_*/
