#include "code/framework/fx/utils/EffectsUtils.h"
#include <OSLib/oslib.h>
#include "code/framework/utils.h"
using namespace utils;



void fx::draw(OSL_IMAGE *img, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(img==NULL)
		return; 
		
	OSL_IMAGE *res=img;
	fx::imgstate.saveFrom(img);
	
	if(fx1!=NULL)
	{
		res=fx1->applyOn(res);
	}
	
	if(fx2!=NULL)
	{
		res=fx2->applyOn(res);
	}
	if(fx3!=NULL)
	{
		res=fx3->applyOn(res);
	}
	if(fx4!=NULL)
	{
		res=fx4->applyOn(res);
	}
	if(fx5!=NULL)
	{
		res=fx5->applyOn(res);
	}
	
	if (res!=NULL)
	{
		//res->offsetX1=res->offsetX0-res->offsetX1;
		//oslMirrorImageV(res);
		oslDrawImage(res);
	}
	
	fx::imgstate.restoreTo(img);
}

void fx::saveState(StateSavable *obj)
{
	obj->savestate(&state);
}

void fx::restoreState(StateSavable *obj)
{
	obj->restorestate(&state);
}

Positionable * fx::applyFxOnPositionable(Positionable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(fx1!=NULL)
		obj=fx1->applyOnPositionable(obj);
	if(fx2!=NULL)
		obj=fx2->applyOnPositionable(obj);
	if(fx3!=NULL)
		obj=fx3->applyOnPositionable(obj);
	if(fx4!=NULL)
		obj=fx4->applyOnPositionable(obj);
	if(fx5!=NULL)
		obj=fx5->applyOnPositionable(obj);
	
	return obj;
}

Orientable * fx::applyFxOnOrientable(Orientable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(fx1!=NULL)
		obj=fx1->applyOnOrientable(obj);
	if(fx2!=NULL)
		obj=fx2->applyOnOrientable(obj);
	if(fx3!=NULL)
		obj=fx3->applyOnOrientable(obj);
	if(fx4!=NULL)
		obj=fx4->applyOnOrientable(obj);
	if(fx5!=NULL)
		obj=fx5->applyOnOrientable(obj);
	
	return obj;
}

Resizable * fx::applyFxOnResizable(Resizable *obj, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(fx1!=NULL)
		obj=fx1->applyOnResizable(obj);
	if(fx2!=NULL)
		obj=fx2->applyOnResizable(obj);
	if(fx3!=NULL)
		obj=fx3->applyOnResizable(obj);
	if(fx4!=NULL)
		obj=fx4->applyOnResizable(obj);
	if(fx5!=NULL)
		obj=fx5->applyOnResizable(obj);
	
	return obj;
}



