#include "code/framework/particles/complete/animFactories/abstract/AbstractAnimationFactory.h"
#include "code/framework/particles/complete/animFactories/ControlledAnimationFactory.h"

ControlledAnimationFactory::ControlledAnimationFactory()
{
	m_animation=NULL;
}

ControlledAnimationFactory *ControlledAnimationFactory::clone() const
{
	ControlledAnimationFactory *theclone=new ControlledAnimationFactory();
	if(m_animation!=NULL)
	{
		theclone->setAnim(new Anim(*m_animation));
	}
	return theclone;
}

ControlledAnimationFactory::~ControlledAnimationFactory()
{
	//pas de delete, les animations sont controllées de l'exterieur
}

Anim *ControlledAnimationFactory::newAnimInstance()
{
	if(m_animation==NULL)
		return NULL;
	return new Anim(*m_animation);
}

float ControlledAnimationFactory::getDelayTotal()
{
	return m_animation->getDelayTotal();
}

void ControlledAnimationFactory::setDelayTotal(float d)
{
	m_animation->setDelayTotal(d);
}

void ControlledAnimationFactory::setAnim(Anim *anim)
{
	m_animation=anim;
}






