#include "code/framework/particles/complete/animFactories/abstract/AbstractAnimationFactory.h"
#include "code/framework/particles/complete/animFactories/ExactSameAnimationFactory.h"

ExactSameAnimationFactory::ExactSameAnimationFactory(Anim *anim)
{
	m_animation=anim;
}

ExactSameAnimationFactory *ExactSameAnimationFactory::clone() const
{
	return new ExactSameAnimationFactory(new Anim(*m_animation));
}

ExactSameAnimationFactory::~ExactSameAnimationFactory()
{
	delete m_animation;
}

Anim *ExactSameAnimationFactory::newAnimInstance()
{
	return new Anim(*m_animation);
}

float ExactSameAnimationFactory::getDelayTotal()
{
	return m_animation->getDelayTotal();
}

void ExactSameAnimationFactory::setDelayTotal(float d)
{
	m_animation->setDelayTotal(d);
}







