#include "code/framework/particles/complete/animFactories/ExtractImageFromAnimFactory.h"

ExtractImageFromAnimFactory::ExtractImageFromAnimFactory(Anim *anim)
{
	m_base=anim;
}

ExtractImageFromAnimFactory *ExtractImageFromAnimFactory::clone() const
{
	return new ExtractImageFromAnimFactory(new Anim(*m_base));
}

ExtractImageFromAnimFactory::~ExtractImageFromAnimFactory()
{
	
}

Anim *ExtractImageFromAnimFactory::newAnimInstance()
{
	return new Anim(m_base->getImageName());
}

void ExtractImageFromAnimFactory::setWatched(Anim *ani)
{
	m_base=ani;
}

float ExtractImageFromAnimFactory::getDelayTotal()
{
	return m_base->getDelayTotal();
}

void ExtractImageFromAnimFactory::setDelayTotal(float d)
{
	m_base->setDelayTotal(d);
}




