#include "code/framework/particles/complete/animFactories/abstract/AbstractAnimationFactory.h"
#include "code/framework/particles/complete/animFactories/SuccessiveAnimationFactory.h"
#include "code/framework/utils.h"

SuccessiveAnimationFactory::SuccessiveAnimationFactory(Anim *anim)
{
	m_animations=new vector<Anim *>();
	if(anim!=NULL)
		m_animations->push_back(anim);
	m_current=0;
}

SuccessiveAnimationFactory *SuccessiveAnimationFactory::clone() const
{
	SuccessiveAnimationFactory *theclone=new SuccessiveAnimationFactory();
	
	vector<Anim *>::iterator it;
	for (it=m_animations->begin() ; it < m_animations->end(); it++ )
    {
    	Anim *anim=*it;
    	theclone->addAnimation(new Anim(*anim));
    }
	
	return theclone;
}

SuccessiveAnimationFactory::~SuccessiveAnimationFactory()
{
	vector<Anim *>::iterator it;
	for (it=m_animations->begin(); it!=m_animations->end();it++)
    {
    	delete (*it);
    }
    delete m_animations;
}

void SuccessiveAnimationFactory::addAnimation(Anim *anim)
{
	m_animations->push_back(anim);
}

Anim *SuccessiveAnimationFactory::newAnimInstance()
{
	Anim* anim=m_animations->at(m_current);
	m_current++;
	if(m_current>=m_animations->size())
		m_current=0;
	
	return new Anim(*anim);
}

float SuccessiveAnimationFactory::getDelayTotal()
{
	return m_animations->at(0)->getDelayTotal();
}

void SuccessiveAnimationFactory::setDelayTotal(float d)
{
	vector<Anim *>::iterator it;
	for (it=m_animations->begin(); it!=m_animations->end();it++)
    {
    	(*it)->setDelayTotal(d);
    }
}





