#ifndef PFXFRANDOMSHAKE_H_
#define PFXFRANDOMSHAKE_H_

#include "code/framework/particles/complete/fxFactories/abstract/AbstractLocalParticleEffectFactory.h"


class PFXFRandomShake: public AbstractLocalParticleEffectFactory
{
	private: 
		int m_widthMin;
		int m_widthMax;
		int m_heightMin;
		int m_heightMax;
		int m_timeMin;
		int m_timeMax;
	
	public:
		PFXFRandomShake(int widthMin=0, int widthMax=0, int heightMin=0, int heightMax=0, int timeMin=0, int timeMax=0);
		~PFXFRandomShake();
		AbstractLocalEffect *newLocalEffectInstance(int startX, int startY, int dist, int movingTime, int orientation, int scale, int particleLifespan);
		
		void setWidthMin(int val);
		void setWidthMax(int val);
		void setHeightMin(int val);
		void setHeightMax(int val);
		void setTimeMin(int val);
		void setTimeMax(int val);
		
		int getWidthMin();
		int getWidthMax();
		int getHeightMin();
		int getHeightMax();
		int getTimeMin();
		int getTimeMax();
		
		PFXFRandomShake *clone() const;
};

#endif /*PFXFRANDOMSHAKE_H_*/
