#include "code/framework/resRepo/ResRepoFactory.h"
#include "code/framework/resRepo/FolderRepo.h"

int ResRepoFactory::repotype=RESREPO_TYPE_FOLDER;

void ResRepoFactory::setRepoType(int type)
{
	repotype=type;
}

AbstractResRepo *ResRepoFactory::newInstance(string filename)
{
	switch(repotype)
	{
		case RESREPO_TYPE_RMX:
		{
			//return new RmxArchive(filename);
			return NULL;
			break;
		}
		case RESREPO_TYPE_FOLDER:
		{
			return new FolderRepo(filename);
			break;
		}
		default:
		{
			oslWarning("ResRepoFactory::newInstance : unrecognized repo type, defaulting to 'folder' type");
			return new FolderRepo(filename);
		}
	}
}





