#ifndef CHANNELMANAGER_H_
#define CHANNELMANAGER_H_

#include "code/framework/time/Timer.h"
#include <oslib/oslib.h>


class ChannelManager
{
	private:
		Timer ** m_timers; //tableau de timers
		int *m_limits; //tableau d'entiers temps de réservation
		//bool *m_available; //tableau de booleens channel dispo ou pas

		
		OSL_SOUND **m_sounds; //tableau de pointeurs sur sons 
		//(références pour tests d'égalité pour paramètres des fonctions)
		
		int searchBestChannel(); //recherche la channel a utiliser
		//si tout est pris et reservé à l'infini, ca prendra la 1ere venue, attention
		
		int lookForSound(OSL_SOUND *snd); //recherche dans quelle channel se joue ce son
		
		int m_currentChoice; //permet d'alterner un peu mieux
	
	public:
		ChannelManager();
		~ChannelManager();
		
		//libère toutes les channels
		void reset();
		//renvoient le num de channel
		int playSoundAndReserve(OSL_SOUND *snd, int millisec=-1); //-1 infinite
		int playSound(OSL_SOUND *snd);
		void pauseSound(OSL_SOUND *snd);
		void resumeSound(OSL_SOUND *snd);
		void stopSound(OSL_SOUND *snd); //libere la channel
		/*void pauseAll();
		void resumeAll();*/
		
		//s'il le trouve, il l'arrete et recommence, sinon il le joue
		int restartSound(OSL_SOUND *snd);
		int restartSoundAndReserve(OSL_SOUND *snd, int millisec=-1);
		
		void blockChannel(int num); //n'autorise pas le manager a utiliser cette channel
	
};


#endif /*CHANNELMANAGER_H_*/
