#include "code/framework/time/Timer.h"

Timer::Timer()
{
	m_startedTime=0;
	//m_endedTime=0;
	m_accumulation=0;
	m_running=false;
}

Timer::Timer(const Timer &t)
{
	m_running=t.m_running;
	m_startedTime=t.m_startedTime;
	m_accumulation=t.m_accumulation;
}

void Timer::start() //resume
{
	if(!m_running)
	{
		m_running=true;
		m_startedTime=clock();
	}	
}

void Timer::reset()
{
	m_startedTime=0;
	if(m_running)
		m_startedTime=clock();
		
	//m_endedTime=0;
	m_accumulation=0;
}

void Timer::restart()
{
	reset();
	start();
}

void Timer::stop()
{
	if(m_running)
	{
		m_running=false;
		//m_endedTime=clock();
		m_accumulation += (clock()-m_startedTime);
	}
}

long int Timer::getTime()
{
	if(m_running) 
		return (m_accumulation+clock()-m_startedTime) / ((long int) CLK_TCK/1000);
 	else 
 		return m_accumulation / ((long int) CLK_TCK/1000);
}

bool Timer::isRunning()
{
	return m_running;
}


bool Timer::operator == (Timer& t)
{
	return (getTime()==t.getTime());
}


Timer& Timer::operator = (const Timer& t)
{
	m_running=t.m_running;
	m_startedTime=t.m_startedTime;
	m_accumulation=t.m_accumulation;
	return (*this);
}










