#ifndef COMBONUMBERDRAWERH_
#define COMBONUMBERDRAWERH_

#include <oslib/oslib.h>
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/time/Delayer.h"
#include "code/game/combos/ComboCounter.h"
#include "code/framework/interfaces/Drawable.h"
#include "code/framework/interfaces/Positionable.h"
#include "code/framework/interfaces/StateSavable.h"

class ComboNumberDrawer : public Drawable, public Positionable
{
	private:
		OSL_IMAGE *m_img_combo_in; //"combos" ou "chains"
		OSL_IMAGE **m_img_numbers_in; //les chiffres
		OSL_IMAGE *m_img_combo_out; //"combos" ou "chains"
		OSL_IMAGE **m_img_numbers_out; //les chiffres
		
		OSL_IMAGE *m_img_num1_in; //pointeur sur le 1er chiffre actuel
		OSL_IMAGE *m_img_num2_in; //pointeur sur le 2eme chiffre actuel
		OSL_IMAGE *m_img_num3_in; //pointeur sur le 3eme chiffre actuel
		OSL_IMAGE *m_img_num1_out; //pointeur sur le 1er chiffre actuel
		OSL_IMAGE *m_img_num2_out; //pointeur sur le 2eme chiffre actuel
		OSL_IMAGE *m_img_num3_out; //pointeur sur le 2eme chiffre actuel
		
		SerialLocalEffect *m_fx_appearWait;
		SerialGlobalEffect *m_fx_waitVanish;
		
		OSL_COLOR m_colors_hot[3];
		OSL_COLOR m_color_normal_in;
		OSL_COLOR m_color_out;
		int m_colornum;
		Delayer *m_colorChangeDelayer; //utilisé pour changer la couleur par intervalle
		int m_currentComboNumber;
		ProgressiveTintEffect *m_fx_tint_in; //ne sera pas progressif
		ProgressiveTintEffect *m_fx_tint_out; //ne sera pas progressif
		
		int m_x, m_y;
	
	public:
		void init(OSL_COLOR color_normal_in, OSL_COLOR color_out, OSL_COLOR color_hot1, OSL_COLOR color_hot2, OSL_COLOR color_hot3, string fontin_folder, string fontin_name, string fontout_folder, string fontout_name, bool invert=false);
		ComboNumberDrawer();
		ComboNumberDrawer(OSL_COLOR color_normal_in, OSL_COLOR color_out, OSL_COLOR color_hot1, OSL_COLOR color_hot2, OSL_COLOR color_hot3, bool invert=false);
		ComboNumberDrawer(OSL_COLOR color_normal_in, OSL_COLOR color_out, OSL_COLOR color_hot1, OSL_COLOR color_hot2, OSL_COLOR color_hot3, string fontin_folder, string fontin_name, string fontout_folder, string fontout_name, bool invert=false);
		~ComboNumberDrawer();
		//void notifyCombo(int nb); //ici nb=nombre d'explosions, donc combos=nb-1
		void sync(ComboCounter *cc);
		bool isInSync(ComboCounter *cc);
		//void drawXY(int x, int y);
		void update();
		int getComboNum();
		void reset();
		
		//Positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//Drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//Statesavable
		State *savestate(State * state);
		void restorestate(State * state);
		
};

#endif /*COMBONUMBERDRAWERH_*/
