#ifndef PDR4CCOMBONUMBERDRAWER_H_
#define PDR4CCOMBONUMBERDRAWER_H_

#include <oslib/oslib.h>
#include "code/framework/fx/EffectsLib.h"
#include "code/framework/time/Delayer.h"
#include "code/game/combos/ComboCounter.h"

class PDR4CComboNumberDrawer
{
	private:
		OSL_IMAGE *m_img_combo_in; //"combos" ou "chains"
		OSL_IMAGE **m_img_numbers_in; //les chiffres
		OSL_IMAGE *m_img_combo_out; //"combos" ou "chains"
		OSL_IMAGE **m_img_numbers_out; //les chiffres
		
		OSL_IMAGE *m_img_num1_in; //pointeur sur le 1er chiffre actuel
		OSL_IMAGE *m_img_num2_in; //pointeur sur le 2eme chiffre actuel
		OSL_IMAGE *m_img_num3_in; //pointeur sur le 3eme chiffre actuel
		OSL_IMAGE *m_img_num1_out; //pointeur sur le 1er chiffre actuel
		OSL_IMAGE *m_img_num2_out; //pointeur sur le 2eme chiffre actuel
		OSL_IMAGE *m_img_num3_out; //pointeur sur le 3eme chiffre actuel
		
		SerialLocalEffect *m_fx_appearWaitVanish;
		//SerialLocalEffect *m_fx_waitVanish;
		
		OSL_COLOR m_colors_hot[3];
		OSL_COLOR m_color_normal_in;
		OSL_COLOR m_color_out;
		int m_colornum;
		Delayer *m_colorChangeDelayer; //utilisé pour changer la couleur par intervalle
		int m_currentComboNumber;
		ProgressiveTintEffect *m_fx_tint_in; //ne sera pas progressif
		ProgressiveTintEffect *m_fx_tint_out; //ne sera pas progressif
	
	public:
		PDR4CComboNumberDrawer(OSL_COLOR color_normal_in, OSL_COLOR color_out, OSL_COLOR color_hot1, OSL_COLOR color_hot2, OSL_COLOR color_hot3, bool invert=false);
		~PDR4CComboNumberDrawer();
		//void notifyCombo(int nb); //ici nb=nombre d'explosions, donc combos=nb-1
		void sync(ComboCounter *cc);
		void drawXY(int x, int y);
		void update();
		int getComboNum();
		void reset();
};
#endif /*PDR4CCOMBONUMBERDRAWER_H_*/
