#include "code/game/levels/LevelFactory.h"
#include <oslib/oslib.h>
#include "code/game/levels/impl/frozen/PDR4CLevelFrozen.h"
#include "code/game/levels/impl/djbeat/PDR4CLevelDjbeat.h"
#include "code/game/levels/impl/mechanicalgroundwork/PDR4CLevelMecha.h"
#include "code/game/levels/impl/test/LevelTest.h"
#include "code/game/levels/impl/ssoup/LevelSsoup.h"
#include "code/game/levels/impl/voltigeur/LevelVoltigeur.h"
#include "code/game/levels/impl/turnandburn/LevelTurnAndBurn.h"
#include "code/game/levels/impl/bioteckprojekt/LevelBioteck.h"
#include "code/game/levels/impl/tetris/LevelTetris.h"
#include "code/game/levels/impl/musong/LevelMusong.h"
#include "code/game/levels/impl/projectsexy/LevelProjectSexy.h"
#include "code/game/levels/impl/8bits/Level8Bits.h"
#include "code/game/levels/impl/cathedral/LevelCathedral.h"
#include "code/game/levels/impl/underwater/LevelUnderwater.h"
#include "code/game/levels/impl/chiptunes/LevelChiptunes.h"

//static
AbstractLevel *LevelFactory::newLevel(string name, int difficulty, int nbPlayers)
{
	if(name=="test")
		return new LevelTest(difficulty, nbPlayers);
	if(name=="ssoup")
		return new LevelSsoup(difficulty, nbPlayers);
	if(name=="voltigeur")
		return new LevelVoltigeur(difficulty, nbPlayers);
	if(name=="turnandburn")
		return new LevelTurnAndBurn(difficulty, nbPlayers);
	if(name=="bioteck")
		return new LevelBioteck(difficulty, nbPlayers);
	if(name=="tetris")
		return new LevelTetris(difficulty, nbPlayers);
	if(name=="musong")
		return new LevelMusong(difficulty, nbPlayers);
	if(name=="sexy")
		return new LevelProjectSexy(difficulty, nbPlayers);
	if(name=="8bits")
		return new Level8Bits(difficulty, nbPlayers);
	if(name=="cathedral")
		return new LevelCathedral(difficulty, nbPlayers);
	if(name=="underwater")
		return new LevelUnderwater(difficulty, nbPlayers);
	if(name=="chiptunes")
		return new LevelChiptunes(difficulty, nbPlayers);
		
		
	if(name=="pdr4cfrozen")
		return new PDR4CLevelFrozen(difficulty, nbPlayers);
	if(name=="pdr4cdjbeat")
		return new PDR4CLevelDjbeat(difficulty, nbPlayers);
	if(name=="pdr4cmecha")
		return new PDR4CLevelMecha(difficulty, nbPlayers);
	
	fatalError(("LevelFactory: level named '"+name+"' does not exist.").c_str());
	
	return NULL;
}










