#include "code/game/levels/utils/JokerDrawer.h"
#include "code/game/pieces/PiecesBufferFactory.h"

JokerDrawer::JokerDrawer()
{
	m_img_ray1=PiecesBufferFactory::getJokerImage1();
	m_img_ray2=PiecesBufferFactory::getJokerImage2();
	
	m_fx_size1=new SizeWowEffect(10, 10, 10, 10, 15, 15);
	m_fx_size2=new SizeWowEffect(20, 20, 0, 0, 27, 27);
	m_fx_rot1=new RotationEffect(171, false);
	m_fx_rot2=new RotationEffect(97, false);
	
	m_fx_size1->start();
	m_fx_size2->start();
	m_fx_rot1->start();
	m_fx_rot2->start();
}

JokerDrawer::~JokerDrawer()
{
	delete m_fx_size1;
	delete m_fx_rot1;
	delete m_fx_rot2;
	delete m_fx_size2;
}

void JokerDrawer::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	fx::drawXY(m_img_ray1, x, y, m_fx_size1, m_fx_rot1, fx1, fx2, fx3);
	fx::drawXY(m_img_ray2, x, y, m_fx_size2, m_fx_rot2, fx1, fx2, fx3);
}

void JokerDrawer::update()
{
	m_fx_rot1->update();
	m_fx_rot2->update();
	m_fx_size1->update();
	m_fx_size2->update();
}




