#include "code/game/levels/utils/MCOContentCombo.h"
#include "code/framework/fx/EffectsLib.h"

MCOContentCombo::MCOContentCombo(Anim *explode_clone, Anim *shine_clone, OSL_IMAGE **numbers, int nbCombos)
{
	m_anim_explode=explode_clone;
	m_anim_shine=shine_clone;
	m_img_combo=numbers;
	m_nbCombos=nbCombos;
	m_x=0;
	m_y=0;
}

MCOContentCombo::~MCOContentCombo()
{
	delete m_anim_explode;
	delete m_anim_shine;
}

int MCOContentCombo::getNbCombos()
{
	return m_nbCombos;
}

//drawable
void MCOContentCombo::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(m_anim_explode->isRunning() || m_anim_explode->finished())
	{
		fx::drawXY(m_anim_explode->getImage(), m_x, m_y,fx1,fx2,fx3,fx4,fx5);
	}
	else //!m_anim_explode->isRunning() || m_anim_explode->finished()
	{
		if(m_nbCombos<=20)
		{
			fx::drawXY(m_img_combo[m_nbCombos], m_x, m_y,fx1,fx2,fx3,fx4,fx5);
		}
		else //m_nbCombos >20
		{
			fx::drawXY(m_img_combo[21], m_x, m_y,fx1,fx2,fx3,fx4,fx5);
		}
		
		if(m_anim_shine->isRunning())
		{
			fx::drawXY(m_anim_shine->getImage(), m_x, m_y,fx1,fx2,fx3,fx4,fx5);
		}
	}
}

void MCOContentCombo::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(m_anim_explode->isRunning() || m_anim_explode->finished())
	{
		fx::drawXY(m_anim_explode->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
	}
	else //!m_anim_explode->isRunning() && !finished
	{
		if(m_nbCombos<=20)
		{
			fx::drawXY(m_img_combo[m_nbCombos],x,y,fx1,fx2,fx3,fx4,fx5);
		}
		else //m_nbCombos >20
		{
			fx::drawXY(m_img_combo[21],x,y,fx1,fx2,fx3,fx4,fx5);
		}
		
		if(m_anim_shine->isRunning())
		{
			fx::drawXY(m_anim_shine->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
		}
	}
}

//playable
void MCOContentCombo::update()
{
	m_anim_explode->update();
	m_anim_shine->update();
}

void MCOContentCombo::start()
{
	m_anim_explode->start();
}

void MCOContentCombo::stop()
{
	m_anim_explode->stop();
	m_anim_shine->stop();
}

void MCOContentCombo::reset()
{
	m_anim_explode->reset();
}

void MCOContentCombo::restart()
{
	m_anim_explode->restart();
}

bool MCOContentCombo::isRunning()
{
	return m_anim_explode->isRunning();
}


//positionable
void MCOContentCombo::setX(int x)
{
	m_x=x;
}

void MCOContentCombo::setY(int y)
{
	m_y=y;
}

int MCOContentCombo::getX()
{
	return m_x;
}

int MCOContentCombo::getY()
{
	return m_y;
}

State *MCOContentCombo::savestate(State * state)
{
	state->m_x=m_x;
	state->m_y=m_y;
	return state;
}

void MCOContentCombo::restorestate(State * state)
{
	m_x=state->m_x;
	m_y=state->m_y;
}

int MCOContentCombo::specialEvent(int event)
{
	if(event==MCOCONTENT_EVENT_COMBO_GETNB)
		return m_nbCombos;
	else if(event==MCOCONTENT_EVENT_COMBO_DECREMENT)
	{
		m_nbCombos--;
		m_anim_shine->restart();
	}
	return 0;
}
