#ifndef MCOCONTENTCOMBO_H_
#define MCOCONTENTCOMBO_H_
#include "code/game/grid/AbstractMCOContent.h"
#include "code/framework/anim/Anim.h"
#include "code/framework/State.h"
#include "code/game/levels/utils/MCOContentEvents.h"


class MCOContentCombo : public AbstractMCOContent
{
	private:
		Anim *m_anim_shine;
		Anim *m_anim_explode;
		OSL_IMAGE ** m_img_combo; //tableau de pointeurs, uniquement en référence, ne pas deleter
		int m_nbCombos;
		int m_x, m_y;
	
	public:
		MCOContentCombo(Anim *explode_clone, Anim *shine_clone, OSL_IMAGE **numbers, int nbCombos);
		~MCOContentCombo();
		
		int specialEvent(int event);
		int getNbCombos();
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*MCOCONTENTCOMBO_H_*/
