#ifndef MCOCONTENTFLAGGED_H_
#define MCOCONTENTFLAGGED_H_

#include "code/game/grid/AbstractMCOContent.h"
#include "code/game/levels/utils/MCOContentEvents.h"

class MCOContentFlagged : public AbstractMCOContent
{
	private:
		AbstractMCOContent *m_mcoc;
		bool m_flagged;
	
	public:
		MCOContentFlagged(AbstractMCOContent *mcoc);
		~MCOContentFlagged();
		
		bool isFlagged();
		void setFlag(bool flag=true);
		
		int specialEvent(int event);		
		
		//drawable
		void draw(AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		void drawXY(int x, int y, AbstractLocalEffect *fx1=NULL, AbstractLocalEffect *fx2=NULL, AbstractLocalEffect *fx3=NULL, AbstractLocalEffect *fx4=NULL, AbstractLocalEffect *fx5=NULL);
		
		
		//playable
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		
		//positionable
		void setX(int x);
		void setY(int y);
		int getX();
		int getY();
		
		//statesaveable
		State *savestate(State * state);
		void restorestate(State * state);
};

#endif /*MCOCONTENTFLAGGED_H_*/
