#include "code/game/levels/utils/MCOContentSimpleAnimated.h"
#include "code/framework/fx/EffectsLib.h"

MCOContentSimpleAnimated::MCOContentSimpleAnimated(Anim *aclone_bg, Anim *aclone_overlay, Anim *aclone_explosion)
{
	m_anim_overlay=aclone_overlay;
	m_anim_bg=aclone_bg;
	m_anim_explosion=aclone_explosion;
	m_state=0;
	
	m_anim_overlay->restart();
}

MCOContentSimpleAnimated::~MCOContentSimpleAnimated()
{
	delete m_anim_overlay;
	delete m_anim_bg;
	delete m_anim_explosion;
}

//drawable
void MCOContentSimpleAnimated::draw(AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	if(m_state==0)
	{
		fx::drawXY(m_anim_bg->getImage(),m_anim_bg->getX(),m_anim_bg->getY(),fx1,fx2,fx3,fx4,fx5);
		fx::drawXY(m_anim_overlay->getImage(),m_anim_bg->getX(),m_anim_bg->getY(),fx1,fx2,fx3,fx4,fx5);
	}
	else
		fx::drawXY(m_anim_explosion->getImage(),m_anim_bg->getX(),m_anim_bg->getY(),fx1,fx2,fx3,fx4,fx5);
		
	
}

void MCOContentSimpleAnimated::drawXY(int x, int y, AbstractLocalEffect *fx1, AbstractLocalEffect *fx2, AbstractLocalEffect *fx3, AbstractLocalEffect *fx4, AbstractLocalEffect *fx5)
{
	
	
	if(m_state==0)
	{
		fx::drawXY(m_anim_bg->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
		fx::drawXY(m_anim_overlay->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
	}
	else
		fx::drawXY(m_anim_explosion->getImage(),x,y,fx1,fx2,fx3,fx4,fx5);
	
	//oslSetAlpha(OSL_FX_DEFAULT, 0); TODO: enlevé mais pourquoi c'etait là?
}

//playable
void MCOContentSimpleAnimated::update()
{
	m_anim_bg->update();
	m_anim_overlay->update();
	m_anim_explosion->update();
}

void MCOContentSimpleAnimated::start()
{
	if(m_state==0)
	{
		m_anim_bg->start();
		m_anim_overlay->start();
	}
	else
		m_anim_explosion->start();
}

void MCOContentSimpleAnimated::stop()
{
	if(m_state==0)
	{
		m_anim_bg->stop();
		m_anim_overlay->stop();
	}
	else
		m_anim_explosion->stop();
}

void MCOContentSimpleAnimated::reset()
{
	if(m_state==0)
	{
		m_anim_bg->reset();
		m_anim_overlay->reset();
	}
	else
		m_anim_explosion->reset();
}

void MCOContentSimpleAnimated::restart()
{
	if(m_state==0)
	{
		m_anim_bg->restart();
		m_anim_overlay->restart();
	}
	else
		m_anim_explosion->restart();
}

bool MCOContentSimpleAnimated::isRunning()
{
	if(m_state==0)
		return m_anim_overlay->isRunning();
	return m_anim_explosion->isRunning();
}


//positionable
void MCOContentSimpleAnimated::setX(int x)
{
	if(m_state==0)
	{
		m_anim_bg->setX(x);
		m_anim_overlay->setX(x);
	}
	else
		m_anim_explosion->setX(x);
}

void MCOContentSimpleAnimated::setY(int y)
{
	if(m_state==0)
	{
		m_anim_bg->setY(y);
		m_anim_overlay->setY(y);
	}
	else
		m_anim_explosion->setY(y);
}

int MCOContentSimpleAnimated::getX()
{
	if(m_state==0)
		return m_anim_overlay->getX();
	return m_anim_explosion->getX();
}

int MCOContentSimpleAnimated::getY()
{
	if(m_state==0)
		return m_anim_overlay->getY();
	return m_anim_explosion->getY();
}

State *MCOContentSimpleAnimated::savestate(State * state)
{
	if(m_state==0)
		return m_anim_overlay->savestate(state);
	return m_anim_explosion->savestate(state);
}

void MCOContentSimpleAnimated::restorestate(State * state)
{
	if(m_state==0)
	{
		m_anim_bg->restorestate(state);
		m_anim_overlay->restorestate(state);
	}
	else
		m_anim_explosion->restorestate(state);
}

int MCOContentSimpleAnimated::specialEvent(int event)
{
	if(MCOCONTENT_EVENT_EXPLODE==event)
	{
		if(m_state==0)
		{
			m_anim_overlay->stop();
			m_anim_bg->stop();
			m_anim_explosion->start();
			m_state=1;
		}
	}
	return 0;
}







