#ifndef EXPLOSION_H_
#define EXPLOSION_H_

#include <oslib/oslib.h>
#include "code/framework/fx/effectslib.h"

//dessine une explosion sur tout l'écran
//TODO: permettre de la dessiner à une certaine taille.
class Explosion
{
	private:
		int m_time; //le temps que ca dure en tout
		int m_current; //ou on en est
		int m_x, m_y; //position
		//int m_expansion; //taille finale
		ProgressiveAlphaEffect *m_vanish; //le dernier tiers du temps, ca disparait
		OSL_IMAGE * m_particle; //la "particule"
		SizeWowEffect * m_growEffects[5]; //on va dessiner 5 fois l'image a la fin
		ProgressiveTintEffect * m_tint[5];
		bool m_running;
		
		
	public:
		~Explosion();
		Explosion(int duration, int x, int y, u32 colorFrom, u32 colorTo);
		void draw();
		void update();
		void start();
		void stop();
		void reset();
		void restart();
		bool isRunning();
		bool finished();
};

#endif /*EXPLOSION_H_*/
