#ifndef QJSCOREMENU_H_
#define QJSCOREMENU_H_

#include <oslib/oslib.h>
#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/bmpFont/BmpText.h"
#include "code/framework/anim/Anim.h"
#include "code/game/saves/GameSave.h"

class QJScoreMenu
{
	private:
		GameSave *m_gamesave;
		int m_linesize;
		int m_margin;
		int m_color;
		int m_col1width;
	
		BmpFont *m_font;
		BmpFont *m_font_big;
		
		BmpText **m_texts_levels; //tableau
		
		BmpText *m_text_level; //titre du level
		BmpText *m_text_score_title;
		BmpText *m_text_score;
		BmpText *m_text_combos_title;
		BmpText *m_text_combos;
		
		BmpText *m_text_ok;
		Anim *m_anim_buttons;
		OSL_IMAGE *m_img_bg;
		
		OSL_SOUND *m_music;
		
		int m_selected;
		
		bool keys();
		void draw();
		void initTexts();
		
	public:
		QJScoreMenu();
		~QJScoreMenu();
		
		void go();
		
};

#endif /*QJSCOREMENU_H_*/
