#ifndef YOUWINDIALOG_H_
#define YOUWINDIALOG_H_

#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/framework/bmpFont/BmpFont.h"
#include "code/framework/bmpFont/BmpText.h"
#include "code/game/levels/abstract/AbstractLevel.h"
#include "code/game/menus/qj/dialogs/AbstractDialog.h"

using namespace std;
using namespace utils;

class YouWinDialog : public AbstractDialog
{
	private:
				
		BmpFont *m_font_big;
		BmpFont *m_font_normal;
		BmpFont *m_font_small;
		
		BmpText *m_text_title;
		BmpText *m_text_best_score_title;
		BmpText *m_text_best_score;
		BmpText *m_text_your_score_title;
		BmpText *m_text_your_score;
		BmpText *m_text_best_combo_title;
		BmpText *m_text_best_combo;
		BmpText *m_text_your_combo_title;
		BmpText *m_text_your_combo;
		BmpText *m_text_playagain;
		BmpText *m_text_yes;
		BmpText *m_text_no;
		
		OSL_SOUND *m_music;
		
		bool m_isBestCombo;
		bool m_isBestScore;
		
		OSL_IMAGE *m_img_cross;
		OSL_IMAGE *m_img_square;
	
	public:
		YouWinDialog(string level_code, int level_difficulty, int score, int combos, int bestscore, int bestcombos);
		~YouWinDialog();
		
		void startSpecific();
		void drawSpecific();
		void updateSpecific();
		int keys();
};

#endif /*YOUWINDIALOG_H_*/
