#ifndef GAMESAVE_H_
#define GAMESAVE_H_

#include <string>
#include "code/framework/Properties.h"
#include <oslib/oslib.h>
#include <psputility_savedata.h>

using namespace std;

class GameSave
{
	private:
		static unsigned int m_size_icon0;
		bool m_save_exists;
		
		
		Properties *m_props;
		void initSavedata(SceUtilitySavedataParam * savedata, PspUtilitySavedataMode mode);
		void cleanSavedata(SceUtilitySavedataParam * savedata);
		
		void setNbLevelsPlayedTotal(int nb);
		void setNbLevelsWonTotal(int nb);
		void setNbPlayedForLevel(string levelcode, int difficulty, int nb);
		void setNbWonForLevel(string levelcode, int difficulty, int nb);
		
		void load();
		
		static string difficultyToString(int difficulty);
		static unsigned char *__attribute__((aligned(16))) bin2c(string filename);
		
	public:
		GameSave();
		~GameSave();
		void save();
		Properties* getProps();
				
		//repris de profile.h
		int getScoreForLevel(string levelcode, int difficulty);
		void setScoreForLevel(string levelcode, int difficulty, int score);
		
		int getCombosForLevel(string levelcode, int difficulty);
		void setCombosForLevel(string levelcode, int difficulty, int maxcombos);
		
		int getNbPlayedForLevel(string levelcode, int difficulty);
		int getNbWonForLevel(string levelcode, int difficulty);
		int getNbLostForLevel(string levelcode, int difficulty);
		
		void addWonForLevel(string levelcode, int difficulty);
		void addLostForLevel(string levelcode, int difficulty);
		
		int getNbLevelsPlayedTotal();		
		int getNbLevelsWonTotal();
		int getNbLevelsLostTotal();
		
		float getWinRatioForLevel(string levelcode, int difficulty);
		string getWinRatioStrForLevel(string levelcode, int difficulty);
		
		float getWinRatioTotal();
		string getWinRatioStrTotal();
};

#endif /*GAMESAVE_H_*/
