#include "code/tests/TestAnimationSimple.h"
#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"

using namespace std;
using namespace utils;

//construction
TestAnimationSimple::TestAnimationSimple()
{
	oslSetKeyAutorepeat(OSL_KEYMASK_UP|OSL_KEYMASK_DOWN,40,4);
	
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_anim=new Anim("res/tests/anim/simplestar/star1.png", 80.0f); //test creation avec ajout d'images
	m_anim->addImage("res/tests/anim/simplestar/star2.png");
	m_anim->addImage("res/tests/anim/simplestar/star3.png");
	m_anim->addImage("res/tests/anim/simplestar/star4.png");
	m_anim->addImage("res/tests/anim/simplestar/star5.png");
	m_anim->addImage("res/tests/anim/simplestar/star6.png");
	m_anim->addImage("res/tests/anim/simplestar/star7.png");
	m_anim->addImage("res/tests/anim/simplestar/star8.png");
	m_anim->addImage("res/tests/anim/simplestar/star9.png");
	m_anim->addImage("res/tests/anim/simplestar/star10.png");
	m_anim->addImage("res/tests/anim/simplestar/star11.png");
	m_anim->addImage("res/tests/anim/simplestar/star1.png");
	m_anim->addImage("res/tests/anim/simplestar/star1.png");
	m_anim->addImage("res/tests/anim/simplestar/star11.png");
	m_anim->addImage("res/tests/anim/simplestar/star10.png");
	m_anim->addImage("res/tests/anim/simplestar/star9.png");
	m_anim->addImage("res/tests/anim/simplestar/star8.png");
	m_anim->addImage("res/tests/anim/simplestar/star7.png");
	m_anim->addImage("res/tests/anim/simplestar/star6.png");
	m_anim->addImage("res/tests/anim/simplestar/star5.png");
	m_anim->addImage("res/tests/anim/simplestar/star4.png");
	m_anim->addImage("res/tests/anim/simplestar/star3.png");
	m_anim->addImage("res/tests/anim/simplestar/star2.png");
	m_anim->addImage("res/tests/anim/simplestar/star1.png");
	
	m_anim->setReferencePointCenter();
	m_anim->setX(240);
	m_anim->setY(136);
	m_anim->start();
	//11 images différentes mises en buffer normalement
	
}

//destruction
TestAnimationSimple::~TestAnimationSimple()
{
	delete m_anim;
	
}

//demarrage du menu
int TestAnimationSimple::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		m_anim->update();
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestAnimationSimple, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestAnimationSimple::drawScene()
{
	oslClearScreen(RGB(0,0,0));
	
	//dessin des animations a leur place
	m_anim->draw();
	
	oslDrawString(10, 250, ("delay total: " + toString(m_anim->getDelayTotal())).c_str());
	oslDrawString(10, 260, ("images in buffer: " + toString(Anim::getNbBufferedImages())).c_str());
}

//gestion des touches
int TestAnimationSimple::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	//ajout d'une animation
	if(osl_pad.pressed.R)
	{
		
	}
	//retrait d'une animation
	else if(osl_pad.pressed.L)
	{
		
	}
	
	
		
	if (osl_pad.pressed.up)
	{
		float delay=m_anim->getDelayTotal();
		delay++;
		m_anim->setDelayTotal(delay);
	}
	else if(osl_pad.pressed.down)
	{
		float delay=m_anim->getDelayTotal();
		delay--;
		if(delay>0.0f)
			m_anim->setDelayTotal(delay);
	}
	else if(osl_pad.pressed.left)
	{
		
	}
	else if(osl_pad.pressed.right)
	{
		
	}
	
	if(osl_pad.pressed.select)
	{
	
	}
	
	return MENU_NOACTION;
}





































