#ifndef TESTLEVELEDITOR_H_
#define TESTLEVELEDITOR_H_

#include <oslib/oslib.h>
#include "code/framework/anim/Anim.h"
#include <vector>
#include "code/game/pieces/abstract/AbstractPiece.h"
#include "code/framework/Pos.h"
#include <string>

using namespace std;

class TestLevelEditor
{
	private:
		bool m_skip;
		int m_action;
		
		int m_nbCols;
		vector<vector<AbstractPiece *> *> *m_grid;
		
		void drawScene();
		int keys();
		
		int m_linesDrawn; //=12;
		int m_lineTopNum; //=0;
		int m_lineDownNum; //=11;
		
		Pos m_gridPixPos; //a calculer selon nombre de lignes
		Pos m_selectorPixPos;
		Pos m_selectorGridPos;
		
		/*bool m_modifier_pieceSelect; //suivant piece, changer couleur, forme, nbre combo, ajouter/retirer shield
		bool m_modifier_lineSelect; //copier coller, up, down, decaler droite/gauche
		bool m_modifier_cellSelect; //changer type piece, copier coller, effacer
		bool m_modifier_gridSelect; //reset grid, save, add/remove col, quit
		*/
		
		//finalement, 1seul modifier
		int m_modifier;
		string m_msg;
		
		OSL_IMAGE *m_img_random;
		OSL_IMAGE *m_img_randomShielded;
		OSL_IMAGE *m_img_piecelevel;
		
		AbstractPiece *m_pieceUnderCursor;
		
		Pos m_copyMarkerPixPos;
		Pos m_copyMarkerGridPos;
		int m_copyMarkerType;
		
		Pos calculateGridPosition();
		Pos calculateSelectorPosition();
		void addEmptyLine();
		AbstractPiece *findPieceUnderCursor();
		AbstractPiece *findPieceMarked();
		int nextColor(int color);
		int nextShape(int shape);
		int previousColor(int color);
		int previousShape(int shape);
		AbstractPiece *nextType(AbstractPiece *p);
		AbstractPiece *previousType(AbstractPiece *p);
		string generateMessage(AbstractPiece *p);
		
		void goUp(); //recalcule le selecteur et les num de ligne haut et bas
		void goDown();
		
		void resetGrid();
		
		void save();
		
	public:
		
		int go();
		TestLevelEditor();
		~TestLevelEditor();
};

#endif /*TESTLEVELEDITOR_H_*/
