#include "code/tests/TestLinePattern.h"
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"
#include "code/game/gamedef.h"
#include <list>
#include "code/game/pieces/PiecesBufferFactory.h"

using namespace std;
using namespace utils;

//construction
TestLinePattern::TestLinePattern()
{
	PiecesBufferFactory::bufferResources();
	//enableDebug();
	m_action=MENU_NOACTION;
	m_skip=false;

	debug("new linepattern...");
	m_pattern=new LinePattern("res/tests/testcenter/test.pattern");	
	debug("new ok");
	debug("next line");
	m_line=m_pattern->getNextLine();
	
	m_pieceJoker=new PieceJoker();
	
	debug("construction ok");
}

//destruction
TestLinePattern::~TestLinePattern()
{
	delete m_pattern;
	delete m_pieceJoker;
	PiecesBufferFactory::unbufferResources();
}

//demarrage du menu
int TestLinePattern::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		if(m_pieceJoker->destructed())
		{
			delete m_pieceJoker;
			m_pieceJoker=new PieceJoker();
		}
		else
		{
			m_pieceJoker->update();
		}
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestLinePattern, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestLinePattern::drawScene()
{
	debug("dessin");
	oslClearScreen(RGB(0,0,0));
	
	int posX=20;
	int posY=200;
	
	debug("boucle");
//	for(int i=0;i<GAMEDEF_NB_COLS;i++)
//	{
//		debug("getpiece");
//		AbstractPiece *piece=m_line[i];
//		debug("draw piece");
//		piece->drawXY(posX, posY);
//		posX+=GAMEDEF_PIECE_WIDTH;
//	}

	if(m_line==NULL)
	{
		oslDrawString(posX, posY, "c'est fini, a pu..");
	}
	else
	{
		list<AbstractPiece *>::iterator it;
		for (it=m_line->begin(); it!=m_line->end();it++)
		{
			AbstractPiece *p=*it;
			if(p!=NULL)
				p->drawXY(posX, posY);
			posX+=GAMEDEF_PIECE_WIDTH;
		}
	}
	
	m_pieceJoker->drawXY(50, 50);
	
	
	debug("fin dessin");
	oslDrawString(posX, posY-20, ("lines available: " + toString(m_pattern->getNbLinesAvailable())).c_str());
	//oslDrawString(10, 260, ("images in buffer: " + toString(Anim::getNbBufferedImages())).c_str());
}

//gestion des touches
int TestLinePattern::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	
	if(osl_pad.pressed.cross)
	{
		m_line=m_pattern->getNextLine();
	}
	if(osl_pad.pressed.square)
	{
		m_pieceJoker->startDestruct();
	}
	
	return MENU_NOACTION;
}
























