#include "code/tests/TestProgressiveAlpha.h"
#include <oslib/oslib.h>
#include <string>
#include "code/framework/utils.h"
#include "code/game/menus/MenusDefines.h"

using namespace std;
using namespace utils;

//construction
TestProgressiveAlpha::TestProgressiveAlpha()
{
	m_action=MENU_NOACTION;
	m_skip=false;
	
	m_img=oslLoadImageFilePNG("res/tests/fondmenu2.png", OSL_IN_RAM | OSL_SWIZZLED, OSL_PF_8888);
	m_fx=new ProgressiveAlphaEffect(60, 0, 255, 0, 0);
}

//destruction
TestProgressiveAlpha::~TestProgressiveAlpha()
{
	oslDeleteImage(m_img);
	delete m_fx;
}

//demarrage du menu
int TestProgressiveAlpha::go()
{
	while(m_action==MENU_NOACTION)
	{
		oslBenchmarkTest(OSL_BENCH_START);
		
		//touches
		m_action=keys();
		if(m_action==MENU_QUIT)
			return m_action;
		
		//phase d'update
		m_fx->update();
				
		if (!m_skip)
		{
			//phase de dessin
			oslStartDrawing();
			drawScene();
			oslBenchmarkTest(OSL_BENCH_END);
			oslSysBenchmarkDisplay();
			oslEndDrawing();
		}
		
		//End of a frame
        oslEndFrame();
		//Synchronize to ensure the game runs at 60 fps
        m_skip = oslSyncFrame();
		//oslAudioVSync(); //ne sert plus, oslEndFrame le fait
	}
	//il a choisi une option
	enableDebug();
	debug("fin boucle TestProgressiveAlpha, return "+toString(m_action));
	enableDebug(false);
	
	return m_action;	
}

//dessins
void TestProgressiveAlpha::drawScene()
{
	oslClearScreen(RGB(0,0,0));
	
	m_fx->activate();
	oslDrawImageXY(m_img, 0, 0);
	oslSetAlpha(OSL_FX_DEFAULT, 0);
}

//gestion des touches
int TestProgressiveAlpha::keys()
{
	oslReadKeys();
	if (osl_pad.pressed.start) //Exit 
	{
		enableDebug();
		debug("start!");
		enableDebug(false);
		return MENU_MAIN;
	}
	
	//ajout d'une animation
	if(osl_pad.released.R)
	{
		m_fx->restart();
	}
	else if(osl_pad.pressed.R)
	{
		m_fx->reset();
		m_fx->stop();
	}
	//retrait d'une animation
	else if(osl_pad.pressed.L)
	{
		
	}
	
	
		
	if (osl_pad.pressed.up)
	{
		
	}
	else if(osl_pad.pressed.down)
	{
		
	}
	else if(osl_pad.pressed.left)
	{
		
	}
	else if(osl_pad.pressed.right)
	{
		
	}
	
	if(osl_pad.pressed.select)
	{
	
	}
	
	return MENU_NOACTION;
}





































